<?php

class widgetContentMapsis extends cmsWidget {
	
	public function run(){

        $ctype_id = $this->getOption('ctype_id');
        $dataset_id = $this->getOption('dataset');
        $cat_id = $this->getOption('category_id');
        $map_field = $this->getOption('map_field');

        $ctype_id_all = $this->getOption('ctype_id_all');
        $dataset_id_all = $this->getOption('dataset_all');
        $cat_id_all = $this->getOption('category_id_all');
        $map_field_all = $this->getOption('map_field_all');
        $title_field_all = $this->getOption('title_field_all');
        $image_field_all = $this->getOption('image_field_all');
        $limit_all = $this->getOption('limit_all',1);

        $model = cmsCore::getModel('content');
        $ctype = $model->getContentType($ctype_id);

        $model_all = cmsCore::getModel('content');
        $ctype_all = $model_all->getContentType($ctype_id_all);

		// Координаты для карт с одной меткой
		if ($ctype) {
			$slug = null;
			$core = cmsCore::getInstance();

			$ctype_string = $core->uri_controller;
			$slug = !mb_strstr($core->uri, '.html') ? mb_substr($core->uri, mb_strlen($ctype_string)+1) : null;

			if ($cat_id){ $category = $model->getCategory($ctype['name'], $cat_id); } else { $category = false; }
		
			if ($dataset_id){
				$dataset = $model->getContentDataset($dataset_id);
				if ($dataset){
					$model->applyDatasetFilters($dataset);
				} else {
					$dataset_id = false;
				}
			}

			if ($category){ $model->filterCategory($ctype['name'], $category, true); }
		
			if (!$dataset_id){ $model->orderBy('date_pub', 'desc'); }

			// Отключаем фильтр приватности для тех кому это разрешено
			if (cmsUser::isAllowed($ctype['name'], 'view_all')) {
				$model->disablePrivacyFilter();
			}

			// Скрываем записи из скрытых родителей (приватных групп и т.п.)
			$model->filterHiddenParents();

			$items = $model->getContentItems($ctype['name']);

			if ($items) {
				foreach ($items as $i=>$item) {
					if (strpos($core->uri, $item['slug']) !== false) { 
						$item_num = $i;
						break;
					}
				}
				if (preg_match('/[-?0-9]+[,]+[-?0-9]/', $items[$item_num][$map_field])) {  $item_coordinates = $items[$item_num][$map_field]; }
			}
		}
		
		// Массив координат для карт с несколькими метками		
		if ($ctype_all) {
			if ($cat_id_all){ $category_all = $model_all->getCategory($ctype_all['name'], $cat_id_all); } else { $category_all = false; }
		
			if ($dataset_id_all){
				$dataset_all = $model_all->getContentDataset($dataset_id_all);
				if ($dataset_all){
					$model_all->applyDatasetFilters($dataset_all);
				} else {
					$dataset_id_all = false;
				}
			}

			if ($category_all){ $model_all->filterCategory($ctype_all['name'], $category_all, true); }
		
			if (!$dataset_id_all){ $model_all->orderBy('date_pub', 'desc'); }

			// Отключаем фильтр приватности для тех кому это разрешено
			if (cmsUser::isAllowed($ctype_all['name'], 'view_all')) {
				$model_all->disablePrivacyFilter();
			}

			// Скрываем записи из скрытых родителей (приватных групп и т.п.)
			$model_all->filterHiddenParents();

			if ($limit_all != 1) { $items_all = $model_all->limit($limit_all)->getContentItems($ctype_all['name']); } else { $items_all = $model_all->getContentItems($ctype_all['name']); }

			if ($items_all) {
				if ($this->getOption('mapsis_all')==1) { shuffle($items_all); }
		
				$config = cmsConfig::getInstance();
				$location = '';
				$points_ymap = '';
				foreach ($items_all as $i=>$item) {
					if ($item[$map_field_all]) {
						if ($item[$title_field_all]) { $title_all = $item[$title_field_all]; } else { $title_all = $item['title']; }
						if ($item[$image_field_all]) {
							$location .= '['.$item[$map_field_all].',"<img src=\"'.$config->host .'/upload/'.html_image_src($item[$image_field_all], micro).'\" width=\"32px\" />&nbsp;&nbsp;<a '.'href=\"'.$config->host .href_to($ctype_all['name'], $item['slug']).'.html\">'.$title_all.'</a>"], ';
						} else {
							$location .= '['.$item[$map_field_all].',"<a '.'href=\"'.$config->host .href_to($ctype_all['name'], $item['slug']).'.html\">'.$title_all.'</a>"], ';
						}
						$points_ymap .= '['.$item[$map_field_all].'],';
					}
				}
			}
		}

		if (($this->getOption('mapsis_widget')==0 && htmlspecialchars($this->getOption('mapsis_coordinates'))) || ($this->getOption('mapsis_widget')==1 && $ctype && $items && $item_coordinates) || ($this->getOption('mapsis_google_all')==1 && $ctype_all && $items_all) || ($this->getOption('mapsis_yandex_all')==1 && $ctype_all && $items_all)){

			$maps = '';

			if ($this->getOption('mapsis_weather')==1 && $this->getOption('mapsis_panoramio')==0){
				$maps .= '
					<script type="text/javascript" src="https://maps.googleapis.com/maps/api/js?v=3.exp&key=AIzaSyC1WHBu7W9npwFZgABlFjmdjIxr3ZRiaaI&language=ru&libraries=weather"></script>
				';
			}
			
			if ($this->getOption('mapsis_panoramio')==1 && $this->getOption('mapsis_weather')==0){
				$maps .= '
					<script src="https://maps.googleapis.com/maps/api/js?v=3.exp&key=AIzaSyC1WHBu7W9npwFZgABlFjmdjIxr3ZRiaaI&signed_in=true&libraries=panoramio"></script>
				';
			}

			if ($this->getOption('mapsis_weather')==1 && $this->getOption('mapsis_panoramio')==1){
				$maps .= '
					<script type="text/javascript" src="https://maps.googleapis.com/maps/api/js?v=3.exp&key=AIzaSyC1WHBu7W9npwFZgABlFjmdjIxr3ZRiaaI&language=ru&libraries=weather,panoramio"></script>
				';
			}

			if ($this->getOption('mapsis_panoramio')==0 && $this->getOption('mapsis_weather')==0 && ($this->getOption('mapsis_google')==1 || $this->getOption('mapsis_route')==1 || $this->getOption('mapsis_google_all')==1)){
				$maps .= '						
					<script type="text/javascript" src="https://maps.googleapis.com/maps/api/js?v=3.exp&key=AIzaSyC1WHBu7W9npwFZgABlFjmdjIxr3ZRiaaI&language=ru"></script>
				';
			}

			if ($this->getOption('mapsis_yandex')==1 || $this->getOption('mapsis_yandex_all')==1){
				$maps .= '						
					<script src="http://api-maps.yandex.ru/2.1/?lang=ru_RU" type="text/javascript"> </script>
				';
			}

			$maps .= '
				<div id="mapsis_widget">
			';

			// Карты с одной меткой
			if (($this->getOption('mapsis_widget')==0 && htmlspecialchars($this->getOption('mapsis_coordinates'))) || ($this->getOption('mapsis_widget')==1 && $ctype && $items && $item_coordinates)){

				if ($this->getOption('mapsis_widget')==0 && htmlspecialchars($this->getOption('mapsis_coordinates'))){
					$coordinates = htmlspecialchars($this->getOption('mapsis_coordinates'));
				} elseif ($this->getOption('mapsis_widget')==1) {
					$coordinates = $item_coordinates;
				}

				if ($this->getOption('mapsis_google')==1){
					$maps .= '
						<div id="gmap_widget" style="width:100%;height:'.htmlspecialchars($this->getOption('mapsis_height')).'px;margin-top:10px;"></div>
						<script type="text/javascript">
							function initialize_gmap_widget() {
								var latlng = new google.maps.LatLng('.$coordinates.');
								var geocoder = new google.maps.Geocoder();
								var infowindow = new google.maps.InfoWindow();
								var mapOptions = { zoom: '.htmlspecialchars($this->getOption('mapsis_zoom')).', center: latlng };
								var gmap = new google.maps.Map(document.getElementById("gmap_widget"), mapOptions);
								var marker = new google.maps.Marker({map: gmap, animation: google.maps.Animation.DROP, position: latlng});
								geocoder.geocode({"latLng": latlng}, function(results, status) {
									if (status == google.maps.GeocoderStatus.OK) {
										if (results[0]) {
					';

					if ($this->getOption('mapsis_text')){
						$maps .= 'infowindow.setContent("'.htmlspecialchars($this->getOption('mapsis_text')).'");';
					} else {
						$maps .= 'infowindow.setContent(results[0].formatted_address);';
					}											

					$maps .= '
											google.maps.event.addListener(marker, "click", function() { infowindow.open(gmap, marker); });
										}
									}
								});
							}
							google.maps.event.addDomListener(window, "load", initialize_gmap_widget);
						</script>
					';
				}

				if ($this->getOption('mapsis_yandex')==1){
					$maps .= '
						<div id="ymap_widget" style="width:100%;height:'.htmlspecialchars($this->getOption('mapsis_height')).'px;"></div>
						<script type="text/javascript">
							ymaps.ready(init_ymap_widget);
							function init_ymap_widget() {
								var myMap = new ymaps.Map("ymap_widget", { center: ['.$coordinates.'], zoom: '.htmlspecialchars($this->getOption('mapsis_zoom')).', controls: ["zoomControl", "fullscreenControl", "typeSelector"] });
								var myPlacemark = new ymaps.Placemark(['.$coordinates.'],{}, {preset: "islands#blueDotIcon"});
								ymaps.geocode(myMap.getCenter()).then(function (res) {
									var firstGeoObject = res.geoObjects.get(0);
					';

					if ($this->getOption('mapsis_text')){
						$maps .= 'myPlacemark.properties.set({ balloonContent: "'.htmlspecialchars($this->getOption('mapsis_text')).'" });';
					} else {
						$maps .= 'myPlacemark.properties.set({ balloonContent: firstGeoObject.properties.get("text") });';
					}											

					$maps .= '
									
								});
								myMap.geoObjects.add(myPlacemark);
							}
						</script>
					';
				}

				if ($this->getOption('mapsis_weather')==1){
					$maps .= '
						<div id="wmap_widget" style="width:100%;height:'.htmlspecialchars($this->getOption('mapsis_height')).'px;margin-top:10px;"></div>
						<script type="text/javascript">
							function initialize_wmap_widget() {
								var latlng = new google.maps.LatLng('.$coordinates.');
								var mapOptions = { zoom: '.htmlspecialchars($this->getOption('mapsis_zoom')).', center: latlng, mapTypeControl: false, streetViewControl: false };
								var wmap = new google.maps.Map(document.getElementById("wmap_widget"), mapOptions);
								var weatherLayer = new google.maps.weather.WeatherLayer({temperatureUnits: google.maps.weather.TemperatureUnit.CELSIUS});
								weatherLayer.setMap(wmap);
								var cloudLayer = new google.maps.weather.CloudLayer();
								cloudLayer.setMap(wmap);
							}
							google.maps.event.addDomListener(window, "load", initialize_wmap_widget);
						</script>
					';
				}

				if ($this->getOption('mapsis_panoramio')==1){
					$maps .= '
						<div id="panoramio_widget" style="width:100%;height:'.htmlspecialchars($this->getOption('mapsis_height')).'px;margin-top:10px;"></div>
						<script type="text/javascript">
							function initialize() {
								var mapOptions = { zoom: '.htmlspecialchars($this->getOption('mapsis_zoom')).', center: new google.maps.LatLng('.$coordinates.') };
								var map = new google.maps.Map(document.getElementById("panoramio_widget"), mapOptions);
								var panoramioLayer = new google.maps.panoramio.PanoramioLayer();
								panoramioLayer.setMap(map);
								map.controls[google.maps.ControlPosition.RIGHT_TOP].push(photoPanel);
							}
							google.maps.event.addDomListener(window, "load", initialize);
						</script>
					';
				}

				if ($this->getOption('mapsis_route')==1){
					$maps .= '
						<div id="route_widget" style="width:100%;height:'.htmlspecialchars($this->getOption('mapsis_height')).'px;margin-top:10px;"></div>
						<script type="text/javascript">
							var directionDisplay;
							var directionsService = new google.maps.DirectionsService();
							var latlng = new google.maps.LatLng('.$coordinates.');
							var geocoder = new google.maps.Geocoder();
							var infowindow = new google.maps.InfoWindow();							
							var map;
							var marker;
							var address_start;
							var address_end;

							function initialize_route_widget() {
								directionsDisplay = new google.maps.DirectionsRenderer();
								var nnovgorod = new google.maps.LatLng('.$coordinates.');
								var myOptions = {
									zoom:'.htmlspecialchars($this->getOption('mapsis_zoom')).',
									mapTypeId: google.maps.MapTypeId.ROADMAP,
									center: nnovgorod
								}
								map = new google.maps.Map(document.getElementById("route_widget"), myOptions);
								marker = new google.maps.Marker({map: map, animation: google.maps.Animation.DROP, position: latlng});
								geocoder.geocode({"latLng": latlng}, function(results, status) {
									if (status == google.maps.GeocoderStatus.OK) {
										if (results[0]) {
					';

					if ($this->getOption('mapsis_text')){
						$maps .= 'infowindow.setContent("'.htmlspecialchars($this->getOption('mapsis_text')).'");';
					} else {
						$maps .= 'infowindow.setContent(results[0].formatted_address);';
					}											

					$maps .= '
											address_start = results[4].formatted_address;
											address_end = results[0].formatted_address;
											google.maps.event.addListener(marker, "click", function() { infowindow.open(map, marker); });
										}
									}
								});
								directionsDisplay.setMap(map);
								directionsDisplay.setPanel(document.getElementById("directionsPanel")); 
								google.maps.event.addListener(directionsDisplay, "directions_changed", function() {
									computeTotalDistance(directionsDisplay.directions);
								});    
							}

							function calcRoute() {
								var start = address_start + ", " + document.getElementById("name_street").value;
								var end = address_end;
								var request = {
									origin:start, 
									destination:end,
									travelMode: google.maps.DirectionsTravelMode.DRIVING
								};
								marker.setMap(null);
								directionsService.route(request, function(response, status) {
									if (status == google.maps.DirectionsStatus.OK) {
										directionsDisplay.setDirections(response);
									}
								});
							}
  
							function computeTotalDistance(result) {
								var total = 0;
								var myroute = result.routes[0];
								for (i = 0; i < myroute.legs.length; i++) {
									total += myroute.legs[i].distance.value;
								}
								total = total / 1000.
								document.getElementById("total").innerHTML = "Расстояние: " + total + " км";
							}   

							google.maps.event.addDomListener(window, "load", initialize_route_widget);
						</script>
						<form>
							<div>
								Введите улицу отправления: 
								<input type="text" size="35" value="" id="name_street" placeholder="ул. Ленина, 8" />
								<input name="StreetSearch" type="button" onClick="calcRoute();" value="Найти" /></p>   
							</div>
							<div class="suggestionsBox" id="suggestions" style="display: none;">
								<img src="upArrow.png" style="position: relative; top: -12px; left: 30px;" alt="upArrow" />
								<div class="suggestionList" id="autoSuggestionsList">&nbsp;</div>
							</div>
						</form>
						<div id="map_canvas"></div>
						<div id="directionsPanel"> 
							<span id="total"></span> 
						</div> 
					';
				}
			}

			// Карты с несколькими метками
			if ($this->getOption('mapsis_google_all')==1 && $ctype_all && $items_all){
				$maps .= '
				<script type="text/javascript" src="system/controllers/content/widgets/mapsis/markerclusterer.js"></script>
					<div id="gmap_all_widget" style="width:100%; height:'.htmlspecialchars($this->getOption('mapsis_height_all')).'px;"></div>
					<script type="text/javascript">
						function initialize_all_widget() {
							var places = ['.$location.'];
							var latlng = new google.maps.LatLng('.$coordinates.');
							var mapOptions = { zoom: '.htmlspecialchars($this->getOption('mapsis_zoom_all')).', center: latlng };
							var map = new google.maps.Map(document.getElementById("gmap_all_widget"), mapOptions);
							setMarkers(map, places);							
						}
						function setMarkers(map, locations) {
							var latlngbounds = new google.maps.LatLngBounds();
							var infowindow = new google.maps.InfoWindow();
							var onMarkerClick = function() {
								var marker = this;
								var latLng = marker.getPosition();
								infowindow.setContent(marker.shadow);
								infowindow.open(map, marker);
							};
							google.maps.event.addListener(map, "click", function() {
								infowindow.close();
							});
							var markers = [];
							for (var i = 0; i < locations.length; i++) {
								var myLatLng = new google.maps.LatLng(locations[i][0], locations[i][1]);
								latlngbounds.extend(myLatLng);
									var marker = new google.maps.Marker({
									position: myLatLng,
									map: map,
									shadow: locations[i][2]
								});
								markers.push(marker);
								google.maps.event.addListener(marker, "click", onMarkerClick);
							}
							var markerCluster = new MarkerClusterer(map, markers);
							map.setCenter( latlngbounds.getCenter(), map.fitBounds(latlngbounds));	 
						};
						google.maps.event.addDomListener(window, "load", initialize_all_widget);
					</script>
				';
			}

			if ($this->getOption('mapsis_yandex_all')==1 && $ctype_all && $items_all){				
				$maps .= '
					<div id="ymap_all_widget" style="width:100%; height:'.htmlspecialchars($this->getOption('mapsis_height_all')).'px;"></div>
					<script type="text/javascript">
						ymaps.ready(function () {
							var myMap = new ymaps.Map("ymap_all_widget", {
								center: [51.671949, 39.202143],
								zoom: '.htmlspecialchars($this->getOption('mapsis_zoom_all')).',
								controls: ["smallMapDefaultSet"]
							}),
							
							clusterer = new ymaps.Clusterer({
								preset: "islands#blueDotIcon",
								groupByCoordinates: false,
								clusterDisableClickZoom: true,
								clusterHideIconOnBalloonOpen: false,
								geoObjectHideIconOnBalloonOpen: false,
							}),
							getPointData = function (index) {
								return {
									balloonContent: index,
									clusterCaption: index
								};
							},
							getPointOptions = function () {
								return {
									preset: "islands#blueDotIcon"
								};
							},
							points = ['.$points_ymap.'],
							balloons = ['.$location.'],
							geoObjects = [];

							for(var i = 0, len = points.length; i < len; i++) {
								geoObjects[i] = new ymaps.Placemark(points[i],
								getPointData(balloons[i][2]),
								getPointOptions());
							}

							clusterer.options.set({
								gridSize: 80,
								clusterDisableClickZoom: false
							});

							clusterer.add(geoObjects);
							
							myMap.geoObjects.add(clusterer);

							myMap.setBounds(clusterer.getBounds(), {
								checkZoomRange: true,
							});
							
						});
					</script>
				';			
			}

			$maps .= '
				</div>
			';

		} else {

			$maps = '';

		} 

		

		
		
		
		
		
		
		
		

		
		return array(
		
            'mapsis' => $maps,

        );

	}
}